﻿using System;

namespace SearchingandSorting
{
    class BinarySearch
    {
        public static void Search(double[] array, double key)
        {
            int min = 0; // min index value
            int max = array.Length - 1; // max index value
            Quicksort.Sort(array); // sort the array
            Search(array, key, min, max);
        }

        private static void Search(double[] array, double key, int min, int max)
        {
            bool found = false;
            while (min <= max)
            {
                int mid = (min + max) / 2;

                if (array[mid] == key)
                {
                    found = true;
                    Console.WriteLine($"{key} was found at index {mid} of the array");
                }
                else if (array[mid] > key)
                    max = mid - 1;
                else if (array[mid] < key)
                    min = mid + 1;
            }
            if (found == false)
                Console.WriteLine($"{key} wasn't found in the array.");
        }

        //Below is my original recursive algorithm (changed to iterative due to stack overflows)

        //private static void Search(double[] array, double key, int min, int max)
        //{
        //    int mid = min + (max - min) / 2; // index for middle element of array

        //    if (min < max)
        //    {
        //        if (key == array[mid]) // found!
        //        {
        //            Console.WriteLine($"{key} found at index {mid} of the array");
        //        }

        //        if (key > array[mid]) // search right(upper) half of array if key is less than the value ar array[mid]
        //        {
        //            min = mid + 1;
        //            Search(array, key, min, max);
        //        }

        //        if (key < array[mid]) // search left(lower) half of the array if the value at array[mid] is less than the key
        //        {
        //            max = mid - 1;
        //            Search(array, key, min, max);
        //        }
        //    }
        //    else // key not found within array
        //    {
        //        Console.WriteLine($"{key} wasn't found in the array.");
        //    }
    }
}
