﻿using System;

namespace SearchingandSorting
{
    class SearchSortOption
    {

        public static void PickSort(double[] array) // sorting options
        {
            int step = 1;
            bool ValidEntry = false;

            if (array.Length >= 256)
                step = 10;
            if (array.Length >= 2048)
                step = 50;
            if (array.Length >= 4096)
                step = 80;

            do
            {
                Console.Clear(); // clear the console window
                Console.WriteLine("Which sorting algorithm would you like to use?");
                Console.WriteLine();
                Console.WriteLine("1 - Bubble sort");
                Console.WriteLine("2 - Insertion sort");
                Console.WriteLine("3 - Quick sort");
                Console.WriteLine();
                Console.Write("Selection: ");
                string option = Console.ReadLine();

                if (option == "1" || option == "2" || option == "3")
                    ValidEntry = true;

                switch (option)
                {
                    case "1": // Bubble
                        Console.Clear(); // clear console window
                        BubbleSort.Bubble(array); // sort the array using bubble sort algorithm
                        Console.WriteLine();
                        Console.WriteLine($"Every {step}th value of the array in ascending order:");
                        Console.WriteLine();
                        DisplayValues.Display(array, step); // display every {step}th value of the array
                        Console.WriteLine();
                        SortDescending.Descend(array); // sort in descending order
                        Console.WriteLine();
                        Console.WriteLine($"Every {step}th value of the array in descending order:");
                        Console.WriteLine();
                        DisplayValues.Display(array, step); // display every {step}th value of the array
                        break;

                    case "2": // Insertion
                        Console.Clear(); // clear console window
                        InsertionSort.Insertion(array); // sort the array using insertion sort algorithm
                        Console.WriteLine();
                        Console.WriteLine($"Every {step}th value of the array in ascending order:");
                        Console.WriteLine();
                        DisplayValues.Display(array, step); // display every {step}th value of the array
                        Console.WriteLine();
                        SortDescending.Descend(array); // sort in descending order
                        Console.WriteLine();
                        Console.WriteLine($"Every {step}th value of the array in descending order:");
                        Console.WriteLine();
                        DisplayValues.Display(array, step); // display every {step}th value of the array
                        break;
                    case "3": // Quick
                        Console.Clear(); // clear console window
                        Quicksort.Sort(array); // sort the array using quick sort algorithm
                        Console.WriteLine();
                        Console.WriteLine($"Every {step}th value of the array in ascending order:");
                        Console.WriteLine();
                        DisplayValues.Display(array, step); // display every {step}th value of the array
                        Console.WriteLine();
                        SortDescending.Descend(array); // sort in descending order
                        Console.WriteLine();
                        Console.WriteLine($"Every {step}th value of the array in descending order:");
                        Console.WriteLine();
                        DisplayValues.Display(array, step); // display every {step}th value of the array
                        break;
                    //case "4": // Binary
                    //break;
                    default:
                        break;
                }
            } while (ValidEntry == false);

        }

        public static void PickSearch(double[] array, double key) // searching options
        {
            bool ValidEntry = false;

            do
            {
                //.Clear(); // clear the console window
                Console.WriteLine("Which search algorithm would you like to use?");
                Console.WriteLine();
                Console.WriteLine("1 - Linear search");
                Console.WriteLine("2 - Binary search");
                Console.WriteLine();
                Console.Write("Selection: ");
                string option = Console.ReadLine();
                Console.WriteLine();

                if (option == "1" || option == "2")
                    ValidEntry = true;

                switch (option)
                {
                    case "1": // Linear
                        //Console.Clear(); // clear console window
                        LinearSearch.Linear(array, key); // sort the array using bubble sort algorithm
                        break;

                    case "2": // Binary
                        //Console.Clear(); // clear console window
                        BinarySearch.Search(array, key);
                        break;
                    default:
                        break;
                }
            } while (ValidEntry == false);

        }
    }
}
